from bge import logic, events
from TextInputBindingBLF import TextInputBLF
import Layouts

UP=1
DOWN=2
CHANGE=3

handlers = {}

def add_handler(event, handler):
    if not event in handlers.keys():
        handlers[event] = []
    handlers[event].append(handler)

inited = False
rep_tic = 0
curr_key = None

def init(lt):
    global t, inited
    if not isinstance(lt, TextInputBLF):
        raise Exception("t is not TextInputBLF")
    t = lt
    inited = True

def next(cont):
    global inited
    if not inited: return
    global rep_tic, curr_key
    #t.set_end("'\n\n" + str(int((time.time()-tm)*1000)))
    #t.set_end("")
    k = logic.keyboard.events
    
    new_curr_key = None
    
    for key_num in (
        events.LEFTARROWKEY,
        events.RIGHTARROWKEY,
        events.BACKSPACEKEY,
        events.DELKEY,
        events.UPARROWKEY,
        events.DOWNARROWKEY
    ):
        if k[key_num]==1:
            new_curr_key = key_num
            
    if new_curr_key and new_curr_key != curr_key:
        curr_key = new_curr_key
        rep_tic = 0
    
    if curr_key and k[curr_key] in (3,0):
        rep_tic = 0
        curr_key = None
    
    obj = cont.owner
    if obj['buffer']:
        t.set_data( t.data[:t.pos] + Layouts.apply_layout(obj['buffer']) + t.data[t.pos:] )
        t.set_pos(t.pos + len(obj["buffer"]))
        obj['buffer'] = ""
        if CHANGE in handlers.keys():
            for h in handlers[CHANGE]: h(CHANGE, t)
    
    elif curr_key and rep_tic==0 or rep_tic>8:
        if curr_key == events.LEFTARROWKEY:
            t.set_pos(t.pos - 1)
        elif curr_key == events.RIGHTARROWKEY:
            t.set_pos(t.pos + 1)
        elif curr_key == events.BACKSPACEKEY and t.pos>0:
            t.set_data( t.data[:t.pos-1] + t.data[t.pos:] )
            t.set_pos(t.pos - 1)
            if CHANGE in handlers.keys():
                for h in handlers[CHANGE]: h(CHANGE, t)
        elif curr_key == events.DELKEY and t.pos < len(t.data):
            t.set_data( t.data[:t.pos] + t.data[t.pos+1:] )
            if CHANGE in handlers.keys():
                for h in handlers[CHANGE]: h(CHANGE, t)
        elif curr_key == events.UPARROWKEY and UP in handlers.keys():
            for h in handlers[UP]: h(UP, t)
        elif curr_key == events.DOWNARROWKEY and DOWN in handlers.keys():
            for h in handlers[DOWN]: h(DOWN, t)
        
    rep_tic+=1
