from bge import render
import bgl
import blf

de_en = False
bl_en = True

def setOrtho2D(x=0, y=0, width=None, height=None):
    if width==None:
        width = render.getWindowWidth()
    if height==None:
        height = render.getWindowHeight()
    bgl.glMatrixMode(bgl.GL_PROJECTION)
    bgl.glLoadIdentity()
    bgl.gluOrtho2D(0, width, 0, height)
    bgl.glMatrixMode(bgl.GL_MODELVIEW)
    bgl.glLoadIdentity()
    
def fixOffset():
    bgl.glTranslatef(-0.5, 0.5, 0)

def preDraw():
    global bl_en, dt_en
    bl_en = bgl.glIsEnabled(bgl.GL_BLEND)
    if not bl_en: bgl.glEnable(bgl.GL_BLEND)
    
    dt_en = bgl.glIsEnabled(bgl.GL_DEPTH_TEST)
    if dt_en: bgl.glDisable(bgl.GL_DEPTH_TEST)

def postDraw():
    if dt_en: bgl.glEnable(bgl.GL_DEPTH_TEST)        
    if not bl_en: bgl.glDisable(bgl.GL_BLEND)

class Font:
    def __init__(self, font, size=12, color=(1.0,1.0,1.0,1.0)):
        self.font_id=blf.load(font)
        self.font=font
        self.size=size
        self.color=color
        self.dpi=72
        
    def setFont(self, font):
        self.font_id=blf.load(font)
        self.font=font
    
    def getSize(self, text):
        blf.size(self.font_id, self.size, self.dpi)
        s=blf.dimensions(self.font_id, text)
        return round(s[0]+0.5), round(s[1]+0.5)
        
    def draw(self, text, x=0, y=0, halign=0, valign=0, fix=True):
        height=render.getWindowHeight()
        try:
            if fix:
                bgl.glTranslatef(0,height,0)
                bgl.glScalef(1.0,-1.0,1.0)
            blf.size(self.font_id, self.size, self.dpi)
            baseline=blf.dimensions(self.font_id, "W")[1]
            w,h=blf.dimensions(self.font_id, text)
            
            blf.position(self.font_id, int(x - (w*halign/2)), int(height-(y + (h*(2-valign)/2))), 0)
            bgl.glColor4f(*self.color)
            bl_en = bgl.glIsEnabled(bgl.GL_BLEND)
            blf.draw(self.font_id, text)
            if bl_en: bgl.glEnable(bgl.GL_BLEND)
        finally:
            if fix:
                bgl.glScalef(1.0,-1.0,1.0)
                bgl.glTranslatef(0,-height,0)
