#!/usr/bin/env python3
# -*- coding: utf-8 -*-

class TextInput:
    def __init__(self, width, word_wrap=True):
        self.begin = ""
        self.end = ""
        
        self.data = ""
        self.cursor = ""
        self.pos = 0
        self.replace_from = 0
        self.replacer = ""
        
        self.word_wrap = word_wrap
        
        self.resize(width)
        
    def set_begin(self, begin):
        self.begin = begin
        
    def set_data(self, data):
        self.data = data
        
    def set_end(self, end):
        self.end = end
        
    def resize(self, width):
        self.width = width
        self.cursor_coords = (-1, -1)
        #self.output = ["", "", ""]
        #self.out_ready = False
        
    def split_text(self, data, x=0, word_wrap = True, cursored = False):
        #позиция курсора ищется с помощью нулевого байта в строке.
        
        if not data: yield "";return# return [""]
        
        #out = []
        
        if '\n' in data:
            lines = data.split('\n')
            #out.extend(self.split_text(lines.pop(0), x, word_wrap))
            for e in self.split_text(lines.pop(0), x, word_wrap): yield e
            for l in lines:
                #out.extend(self.split_text(l, 0, word_wrap))
                for e in self.split_text(l, 0, word_wrap): yield e
            return
            #return out
        
        if not word_wrap:
            #out.append(data[:self.width-x])
            yield data[:self.width-x]
            data = data[self.width-x:]
            offset = 0
            while offset < len(data):
                #out.append(data[offset:offset + self.width])
                yield data[offset:offset + self.width]
                offset += self.width
            return
            #return out
        
        line = ""
        for word in data.split(" "):
            if len(word) > self.width - len(line) - x + (1 if cursored and '\x00' in line else 0):
                #out.append(line.rstrip())
                if line or x!=0:
                    yield line.rstrip()
                    line = ""
                    x = 0
            
            if len(word) <= self.width - len(line) - x + (1 if cursored and '\x00' in line else 0):
                line += word + " "
            
            else:
                #out.extend(self.split_text(word, 0, False))
                buff = None
                for e in self.split_text(word, 0, False):
                    if buff != None: yield buff
                    buff = e
                #line = out.pop() + " "
                line = buff + " "
        
        yield line.rstrip()
        #out.append(line)        
         
        return       
        #return out
        
    #def gen_output(self, force=False):
    #    if not force and self.out_ready:
    #        return
    
    def gen_output(self, x=0):
        data = self.begin
        
        if self.data!=None:
            sdata = self.data
            if self.replacer and self.replace_from < len(sdata):
                sdata = sdata[:self.replace_from] + self.replacer * (len(sdata) - self.replace_from)
            if self.pos < 0: self.pos = 0
            elif self.pos > len(sdata): self.pos = len(sdata)
            
            data += sdata[:self.pos] + (self.cursor if self.cursor else "\x00") + sdata[self.pos:]
        
        if self.end: data += self.end
        
        line = 0
        for e in self.split_text(data, x, self.word_wrap):
            p = e.find("\x00")
            if p>=0:
                self.cursor_coords = (line, p)
                yield e.replace("\x00", "")
            else: yield e
            line += 1
            
    def set_position(self, pos):
        if pos < 0: pos = 0
        elif pos > len(self.data): pos = len(self.data)
        self.pos = pos
        

if __name__=="__main__":
    i = 20
    x=0
    print("_"*i)
    print("."*x, end="")
    t = TextInput(i)
    
    t.begin = "BEGIN> \n"
    t.data = "data"
    t.end = " <END"
    
    #t.cursor = "|"
    
    print( "\n".join(t.gen_output(x)) )
    print(t.cursor_coords)
